<template>
  <div class="content">
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <div style="margin-top: 50px;">
      <span style="font-size: 18px;"
        ><a href="#/dashboard/mata-kuliah-kota" style="color: grey"
          >Mata Kuliah
        </a></span
      >
      <span style="font-size: 17px; padding: 0px 5px"> > </span>
      <span style="font-size: 18px">Update Mata Kuliah</span>
    </div>
    <form ref="form" novalidate class="md-layout" @submit.prevent="onSubmit">
      <md-card
        class="md-layout-item md-size-95 md-small-size-100"
        style="padding: 0px 20px 30px 20px; margin-left: 30px"
      >
        <md-card-header>
          <div class="md-title">
            <h2 style="letter-spacing: 2px;color: green;margin-top:30px;">
              <strong>Update Mata Kuliah KOTA</strong>
            </h2>
          </div>
        </md-card-header>

        <md-card-content>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('nama_mk')">
                <label for="nama_mk">Nama Mata Kuliah...</label>
                <md-input
                  name="nama_mk"
                  id="nama_mk"
                  v-model="mataKuliahData.nama_mk"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span
                  class="md-error"
                  v-if="!$v.mataKuliahData.nama_mk.required"
                  >Nama Mata Kuliah is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('kode_mk')">
                <label for="kode_mk">Kode Mata Kuliah...</label>
                <md-input
                  name="kode_mk"
                  id="kode_mk"
                  v-model="mataKuliahData.kode_mk"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span
                  class="md-error"
                  v-if="!$v.mataKuliahData.kode_mk.required"
                  >Kode Mata Kuliah is required</span
                >
              </md-field>
            </div>
          </div>
          <br />
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('sks_mk')">
                <label for="sks_mk">Jumlah SKS...</label>
                <md-input
                  name="sks_mk"
                  id="sks_mk"
                  v-model="mataKuliahData.sks_mk"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span class="md-error" v-if="!$v.mataKuliahData.sks_mk.required"
                  >SKS Mata Kuliah is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('prodi_id')">
                <label for="prodi_id">Program Studi...</label>
                <md-select
                  name="prodi_id"
                  id="prodi_id"
                  v-model="mataKuliahData.prodi_id"
                  md-dense
                  :disabled="sending"
                >
                  <md-option
                    v-for="(prodi, key) in prodiList"
                    :key="key"
                    :value="prodi.id"
                    style="width:100%; left: 10px;"
                  >
                    {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                  </md-option>
                </md-select>
                <span
                  class="md-error"
                  v-if="!$v.mataKuliahData.prodi_id.required"
                  >Prodi is required</span
                >
              </md-field>
            </div>
          </div>
        </md-card-content>

        <md-card-actions style="padding-top: 50px">
          <md-button
            type="submit"
            class="md-login md-success md-lg md-round"
            :disabled="sending"
            style="height: 50px; width: 140px"
            ><span
              style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
            >
              Submit
            </span>
          </md-button>
        </md-card-actions>

        <md-progress-bar md-mode="indeterminate" v-if="sending" />

        <md-snackbar :md-active.sync="userSaved"
          >Daftar Mata Kuliah Berhasil Diupdate!</md-snackbar
        >
      </md-card>
    </form>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    form: {
      nama_mk: null,
      kode_mk: null,
      sks_mk: null,
      prodi_id: null
    },
    userSaved: false,
    sending: false
  }),
  validations: {
    mataKuliahData: {
      nama_mk: {
        required
      },
      kode_mk: {
        required
      },
      sks_mk: {
        required
      },
      prodi_id: {
        required
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("mataKuliah", ["mataKuliahData"]),
    ...mapState("prodi", ["prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    }
  },
  methods: {
    ...mapActions("mataKuliah", ["getMataKuliah", "updateMataKuliah"]),
    ...mapActions("prodi", ["getProdiList"]),
    async onFetchData() {
      await this.getMataKuliah({ id: this.$route.params.id });
      await this.getProdiList();
    },
    async onSubmit() {
      this.$v.$touch();
      this.sending = true;
      window.setTimeout((this.userSaved = true), 2000);
      // this.userSaved = true;
      if (!this.$v.invalid) {
        try {
          await this.updateMataKuliah({
            id: this.$route.params.id,
            payload: this.mataKuliahData
          });
          this.sending = false;
          this.mataKuliahData = {};
          this.$router.push({ name: "mata-kuliah-kota" });
        } catch (error) {
          this.sending = false;
          throw Error(error);
        }
      }
    },
    getValidationClass(fieldName) {
      const field = this.$v.mataKuliahData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    // this.onResponsiveInverted();
    // window.addEventListener("resize", this.onResponsiveInverted);
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css">
.md-progress-bar {
  margin: 24px;
}
</style>
